const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const stock_adjustment_lines = sequelize.define(
    'stock_adjustment_lines',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

quantity_delta: {
        type: DataTypes.DECIMAL,
      
      

      },

unit_cost: {
        type: DataTypes.DECIMAL,
      
      

      },

line_notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  stock_adjustment_lines.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity


























































//end loop



    db.stock_adjustment_lines.belongsTo(db.stock_adjustments, {
      as: 'stock_adjustment',
      foreignKey: {
        name: 'stock_adjustmentId',
      },
      constraints: false,
    });

    db.stock_adjustment_lines.belongsTo(db.products, {
      as: 'product',
      foreignKey: {
        name: 'productId',
      },
      constraints: false,
    });

    db.stock_adjustment_lines.belongsTo(db.inventory_batches, {
      as: 'batch',
      foreignKey: {
        name: 'batchId',
      },
      constraints: false,
    });

    db.stock_adjustment_lines.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.stock_adjustment_lines.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.stock_adjustment_lines.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return stock_adjustment_lines;
};


